import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import mixer.*;

/*
 * 1.1.1
 * Karl-Adam Karlsson
 * 06-11-01
 *
 * Servlet fr beskar rkning.
 * Testad p localhost med tomcat.
 *
 * synchronized anvnt vid filhanterinegn.
 * Detta borde se till att inget dumt hnder. Eftersom, som jag frstr det
 * r det tomcat som kr det hela med nya trdar varje gng, s
 * synchronized borde se till att tomcat inte trdar till det underligt. 
 *
 */

public class SeparatedCounter extends HttpServlet {
	
  

  public void doGet( HttpServletRequest req, HttpServletResponse res )
    throws IOException
  {
    	
    //res.setContentType( "text/html" );
	
	String htmlTemplate = Mixer.getContent( getHtmlFile("count.html") );
	Mixer m = new Mixer(htmlTemplate);
	
    PrintWriter targetClient = res.getWriter();

    long number = getCounter();
    number++;
	String aNo = Long.toString(number);
	System.out.println(htmlTemplate);
    //targetClient.println( "<title>Servlet Counter</title>" );
    //targetClient.println( "<h1>Greetings visitor number: " + number +"</h1>" );
    
    //Stt variebeln i .html dokumentet till number.
    
    m.add("===number===", aNo);
	res.setContentType("text/html");
	targetClient.println(m.getMix());
    
    
    
    saveCounter(number);
    
    
   
	

	//Skriv ut detta nummer.
    //targetClient.println(  );
    
    //Lgg till ett och spara fil.

    
    targetClient.close();
  }
  
  /*
   * laddar en fil.
   * Var tidigare synchronized, men sg i kllkoden fr mixer att den nd anvnde synchronized,
   * s jag tog bort det hr. Verkade vara overkill
   * att synchroniza dubbelt. 
   * Anvnds fr att ladda till Mixer.
   * Notera att filen mste ligga i rtt mapp.
   * Fr mig, p localhost, var detta examples i tomcat.
   * Men det r ju en instllningsfrga.
   * Finns inte filen skriver man bara ut stacktrace.
   *
   *
   * @param String name The name of the file to load
   * @return File The loaded file.
   */
  private File getHtmlFile(String name){
  	File f = new File(getServletContext().getRealPath(name));
  	
  	return f;
  }
  
  
  /* Syncroniserad getCountermetod, som laddar data frn fil returnerar en long.
   *
   */
  private synchronized long getCounter(){
  	long ano = 0;
  	try{
  		// ppna fil och hmta info om beksnummer.
    	// Anvnder ett statiskt filnamn, eftersom alla skall ju anvnda samma.
		File f = new File(getServletContext().getRealPath("counter"));
	
	
		//Om detta e true har vi skapat, ny. Ergo filen fanns inte vi e allts bekare no. 1 och skall
		// skriva 1 till filen.
		if(f.createNewFile()){
			ano = 0;
			
			return ano;
		}else{
			//Annars lser vi vad som finns och kar med ett.
				FileInputStream fin = new FileInputStream(f);
				ObjectInputStream ois = new ObjectInputStream(fin);
			
				ano = (long)ois.readLong();
				ois.close();
				fin.close();
		}
	}catch(IOException ioe){
		ioe.printStackTrace();
	}
	
  	return ano;
  }
  
  /*
   * Synkronisearad save counter som sparar.
   * long anumber till counterfil.
   */
  private synchronized void saveCounter(long anumber){
  	try{
  		//Tar bort gamla filen.
  		File oldfile = new File(getServletContext().getRealPath("counter"));
  		oldfile.delete();
  		
  		//Skapar nu counter fil
  		File fout = new File(getServletContext().getRealPath("counter"));
  		FileOutputStream os = new FileOutputStream(fout);
  		ObjectOutputStream oos = new ObjectOutputStream(os);
  		
  		//Skriver till tempfil
  		oos.writeLong(anumber);
  		oos.close();
  		os.close();
  	}catch(IOException ioe){
		ioe.printStackTrace();
	}
  }
}