import java.io.*;
import java.util.*;
import mixer.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.LinkedList;
import java.net.InetAddress;
// OBS, anvnder Apache Jakarta Commons FileUpload package
// http://jakarta.apache.org/commons/fileupload/
// http://jakarta.apache.org/commons/io/
import org.apache.commons.fileupload.*;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;

/*
 * Gesllprov, IP2.
 * Interactivator.java
 * Karl-Adam Karlsson
 * 06-11-15
 * 
 * Konstruerar ett html dokument innehllande text och val enligt 
 * data som parser laddat.
 *
 * Kan anvdas som verktyg fr interaktiva berttelser,
 * inspiration frn: http://www.gamebooks.org/show_series_images.php?id=644
 *
 * Man kan ocks ha ett antal andra anvndningsomrden.
 *
 */

public class Interactiveator extends HttpServlet {
   LinkedList allComponents;
   PrintWriter targetClient=null;
   HttpServletRequest req2;
   
   //Doget
  public synchronized void doGet( HttpServletRequest req, HttpServletResponse res )
    throws IOException
  {	
  	res.setContentType( "text/html" );
	targetClient = res.getWriter();
  	req2 = req;
  	
  
  	if( req.getParameterValues("file")!=null ){

  		//Har ett filnamn vi vill anvnda
  		String filename = req.getParameterValues("name")[0];
  		//Parsar filen och fr tillbaka en lnkad lista
  		Parser p = new Parser(filename, this);
  		allComponents = p.parse();
  		
  		//Skriv sedan ut frsta komponenten
  		mixComponent((Komponent)allComponents.getFirst());
  	}
  	else if(req.getParameterValues("radio_button")!=null){
  		// Anropet innehller en targetcomponent
  		// Vi skall d leta reda p denna i allComponents
  		// och 'skriva' ut mha mixer
  		
  		//hmta targetcomponentvrdet frn radio_button
  		String targetname = req.getParameterValues("radio_button")[0];
  		
  		boolean aBool=true;
  		
  		//leta reda p rtt komponent
  		int i=0;
  		while(i<allComponents.size() && aBool){
  			
  			if( ((Komponent)allComponents.get(i)).name.equals(targetname) ){
  				
  				//och mixa ut den.
  				mixComponent((Komponent)allComponents.get(i));
  				aBool=false;
  			}
  			i++;
  		}
  	}else if( (req.getParameterValues("upload")!=null) && req.getParameterValues("upload")[0].equals("true") ){
  		// Fileupload
  		targetClient.println("Observera att om filen redan finns skriver du ver den.");
  		targetClient.println("<form enctype="+'"'+"multipart/form-data"+'"'+ "method="+'"'+"post"+'"'+ "action="+'"'+ req2.getRequestURI() +'"'+">");
		targetClient.print("<input type=");
		targetClient.print('"'+"hidden"+'"');
		targetClient.print("name=" +'"'+"MAX_FILE_SIZE"+'"'+"value="+'"'+"10000000"+'"'+"/>");
        targetClient.println("<input name="+'"'+"userfile"+'"'+"type="+'"'+"file"+'"'+ "/>");
        targetClient.println("<input type=" +'"'+"submit"+'"'+ "value="+'"'+"Submit"+'"'+ "/>");
		targetClient.println("<p>");
        targetClient.println("<input value="+'"'+"Snd"+'"'+ "name="+'"'+"button"+'"' +"type="+'"'+"submit"+'"'+">");
      	targetClient.println("</p></form>");
  		


	}else if(FileUpload.isMultipartContent(req) && req!=null){
	//FILEUPLOAD
		FileItemFactory factory = new DiskFileItemFactory();
		ServletFileUpload upload = new ServletFileUpload(factory);	
		////////////////////////////////////////////////////////////////////
		try{
			List items = upload.parseRequest(req);
			Iterator iter = items.iterator();
			
			while (iter.hasNext()) {
    			FileItem item = (FileItem) iter.next();
    			String name = new String();
	
    			if (item.isFormField()) {
					if(item.getFieldName().equals("name"))
					name = item.getString();
				}
				else{
					byte[] data = item.get();
			
					name = item.getName();
					System.out.println("NAME: "+name);
					File f = new File(getServletContext().getRealPath("docs/"+name));
					FileOutputStream fout = new FileOutputStream(f);
			
					fout.write(data);
					fout.close();
				}
			}
		}catch(FileUploadException foo){
 				targetClient.print(foo.toString());
 			}
  	
  	}else{
  		//Nej, lista filer och lnka till dem.
  		File f = new File(getServletContext().getRealPath("docs"));
  		//notera att alla textfilerna skall ligga i docsmappen.
  		String[] filList;
        filList = f.list();
        LinkedList linked = new LinkedList( Arrays.asList( f.list() ) );
        
        
        // Lite kosmetika
        //targetClient.print("<i><b>:.:.:.:.:.:.:.:.:.:.:.:.:.:.:.:.:.:.:.:.:.:.:</i></b></br>");
        //targetClient.print("<i><b>:...........................................:</i></b></br>");
        targetClient.print("<i><b>:.....Choose your interactive adventure.....:</i></b></br>");
        //targetClient.print("<i><b>:...........................................:</i></b></br>");
        //targetClient.print("<i><b>:.:.:.:.:.:.:.:.:.:.:.:.:.:.:.:.:.:.:.:.:.:.:</i></b></br>");
        //
        InetAddress inAd = InetAddress.getLocalHost();
        
        targetClient.println( "<a href=" +'"'+req2.getRequestURI()+ '?'+ "upload=true"+'"'+'>'+ "Upload a file" +"</a>" );
        targetClient.println("<hr></br>");
        
        //Skapa lnkar i html, s alla filer kan ns
        for(int i=0;i<linked.size();i++){
        	targetClient.println( "<a href=" +'"'+req2.getRequestURI()+ '?'+ "file=true&name="+(String)linked.get(i)+'"'+ '>' +(String)linked.get(i) +"</a>" );
        	targetClient.println("</br>");
        }//end of for
        
        //Alla r listade.
        // Ett tryck p en lnk br fra oss till if:satsen ovan.
  	}

  }//end of doGet
  
  /*
  * Dopost, vidarebefordrar till doget.
  */
  protected void doPost(HttpServletRequest req,
                       HttpServletResponse res) throws ServletException, IOException
  {
  		doGet( req, res );
  }//end of dopost
  
  
  /*
   * Mixes a Komponent into the target html file
   *
   *
   */
  private void mixComponent(Komponent aComponent){
  		String htmlTemplate = Mixer.getContent( getHtmlFile("mall.html") );
		Mixer mix = new Mixer(htmlTemplate);
		
		//Hmta text
		LinkedList txt = new LinkedList( aComponent.getText() );
		
		
		
		// Hmta targets och choices
		
		LinkedList choices = new LinkedList( aComponent.getChoices() );
		LinkedList targets = new LinkedList( aComponent.getTargets() );
		
		
		
			if(choices.size()==0 || targets.size()==0 ){
				//Finns inga alternativ som e okej.
				// ndra mixer till lastpage.html
				htmlTemplate = Mixer.getContent( getHtmlFile("lastpage.html") );
				mix = new Mixer(htmlTemplate);
				
				// Skriv ut texten
					while(txt.size()>0){
						mix.add("<!--===yyy===-->","===storytext===", (String)txt.getFirst() + "</br>" );
						txt.removeFirst();
				}
				
				try{
					InetAddress inAd = InetAddress.getLocalHost();
					mix.add("===url===", req2.getRequestURI()  );//"http://"+inAd.getHostAddress().toString()+ 
			
				}catch(IOException unkHo){
					targetClient.println(unkHo.toString());
				}
				
			
				
			}else{
				
				//lgg till httpaddress
				try{
					InetAddress inAd = InetAddress.getLocalHost();
						
					mix.add("===target===", req2.getRequestURI() );
				}catch(IOException unkHo){
					targetClient.println(unkHo.toString());
				}
		
				// Skriv ut texten
					while(txt.size()>0){
						mix.add("<!--===yyy===-->","===storytext===", (String)txt.getFirst() + "</br>" );
						txt.removeFirst();
				}
				
				// Skriv ut alla handlingsalternativ
				while(choices.size()>0 && targets.size()>0 ){
					mix.add("<!--===xxx===-->","===name===", (String)targets.getFirst() );
					mix.add("<!--===xxx===-->","===val===", (String)choices.getFirst()+"</br>" );
					choices.removeFirst();
					targets.removeFirst();
				}
			}
		
		//Skriv ut komponenten
		targetClient.println(mix.getMix());
  }
  
  
   /*
   * laddar en .html fil.
   *
   * @param String name The name of the file to load
   * @return File The loaded file.
   */
  private File getHtmlFile(String name){
  	File f = new File(getServletContext().getRealPath(name));
  	
  	return f;
  }
  
  /*
   * Returnar servletcontext
   * @param path
   * @return String servletcontext
   */
  public String getContext(String s){
  	return getServletContext().getRealPath(s);
  }

}